Proxmox/setup/motioneye-install.sh

130 lines
3.4 KiB
Bash
Raw Normal View History

2022-04-25 17:14:09 +02:00
#!/usr/bin/env bash
2022-04-18 13:33:08 +02:00
YW=`echo "\033[33m"`
2022-03-08 22:39:37 +01:00
RD=`echo "\033[01;31m"`
BL=`echo "\033[36m"`
GN=`echo "\033[1;92m"`
CL=`echo "\033[m"`
2022-03-11 04:23:55 +01:00
RETRY_NUM=10
2022-03-08 22:39:37 +01:00
RETRY_EVERY=3
NUM=$RETRY_NUM
2022-04-18 13:33:08 +02:00
CM="${GN}${CL}"
CROSS="${RD}${CL}"
BFR="\\r\\033[K"
HOLD="-"
2022-04-25 17:14:09 +02:00
set -o errexit
set -o errtrace
set -o nounset
set -o pipefail
shopt -s expand_aliases
alias die='EXIT=$? LINE=$LINENO error_exit'
trap die ERR
function error_exit() {
trap - ERR
local reason="Unknown failure occured."
local msg="${1:-$reason}"
local flag="${RD}‼ ERROR ${CL}$EXIT@$LINE"
echo -e "$flag $msg" 1>&2
exit $EXIT
}
2022-04-18 13:33:08 +02:00
function msg_info() {
local msg="$1"
echo -ne " ${HOLD} ${YW}${msg}..."
}
2022-03-08 22:39:37 +01:00
2022-04-18 13:33:08 +02:00
function msg_ok() {
local msg="$1"
echo -e "${BFR} ${CM} ${GN}${msg}${CL}"
}
msg_info "Setting up Container OS "
2022-03-08 22:39:37 +01:00
sed -i "/$LANG/ s/\(^# \)//" /etc/locale.gen
locale-gen >/dev/null
while [ "$(hostname -I)" = "" ]; do
1>&2 echo -en "${CROSS}${RD} No Network! "
sleep $RETRY_EVERY
((NUM--))
if [ $NUM -eq 0 ]
then
1>&2 echo -e "${CROSS}${RD} No Network After $RETRY_NUM Tries${CL}"
exit 1
fi
done
2022-04-18 13:33:08 +02:00
msg_ok "Set up Container OS"
msg_ok "Network Connected: ${BL}$(hostname -I)"
2022-03-08 22:39:37 +01:00
2022-04-25 20:02:49 +02:00
wget -q --tries=10 --timeout=5 --spider https://google.com
2022-04-23 19:43:45 +02:00
if [[ $? -eq 0 ]]; then
msg_ok "Internet Online"
else
echo -e "{CROSS}${RD} Internet Offline"
fi
2022-04-18 13:33:08 +02:00
msg_info "Updating Container OS"
apt update &>/dev/null
apt-get -qqy upgrade &>/dev/null
msg_ok "Updated Container OS"
msg_info "Installing Dependencies"
apt-get install -y curl &>/dev/null
apt-get install -y sudo &>/dev/null
msg_ok "Installed Dependencies"
2022-03-08 22:39:37 +01:00
echo -en "${GN} Installing Motion... "
apt-get install motion -y &>/dev/null
systemctl stop motion &>/dev/null
systemctl disable motion &>/dev/null
echo -e "${CM}${CL} \r"
2022-04-18 13:33:08 +02:00
msg_info "Installing FFmpeg"
2022-03-08 22:39:37 +01:00
apt-get install ffmpeg v4l-utils -y &>/dev/null
2022-04-18 13:33:08 +02:00
msg_ok "Installed FFmpeg"
2022-03-08 22:39:37 +01:00
2022-04-18 13:33:08 +02:00
msg_info "Installing Python"
2022-03-08 22:39:37 +01:00
apt-get update &>/dev/null
apt-get install python2 -y &>/dev/null
curl https://bootstrap.pypa.io/pip/2.7/get-pip.py --output get-pip.py &>/dev/null
python2 get-pip.py &>/dev/null
apt-get install libffi-dev libzbar-dev libzbar0 -y &>/dev/null
apt-get install python2-dev libssl-dev libcurl4-openssl-dev libjpeg-dev -y &>/dev/null
2022-04-18 13:33:08 +02:00
msg_ok "Installed Python"
2022-03-08 22:39:37 +01:00
2022-04-18 13:33:08 +02:00
msg_info "Installing MotionEye"
2022-03-08 22:39:37 +01:00
apt-get update &>/dev/null
sudo pip install motioneye &>/dev/null
mkdir -p /etc/motioneye
cp /usr/local/share/motioneye/extra/motioneye.conf.sample /etc/motioneye/motioneye.conf
mkdir -p /var/lib/motioneye
2022-04-18 13:33:08 +02:00
msg_ok "Installed MotionEye"
2022-03-08 22:39:37 +01:00
2022-04-18 13:33:08 +02:00
msg_info "Creating Service"
2022-03-08 22:39:37 +01:00
cp /usr/local/share/motioneye/extra/motioneye.systemd-unit-local /etc/systemd/system/motioneye.service &>/dev/null
systemctl enable motioneye &>/dev/null
systemctl start motioneye
2022-04-18 13:33:08 +02:00
msg_ok "Created Service"
2022-03-08 22:39:37 +01:00
PASS=$(grep -w "root" /etc/shadow | cut -b6);
if [[ $PASS != $ ]]; then
2022-04-18 13:33:08 +02:00
msg_info "Customizing Container"
2022-03-08 22:39:37 +01:00
rm /etc/motd
rm /etc/update-motd.d/10-uname
touch ~/.hushlogin
GETTY_OVERRIDE="/etc/systemd/system/container-getty@1.service.d/override.conf"
mkdir -p $(dirname $GETTY_OVERRIDE)
cat << EOF > $GETTY_OVERRIDE
[Service]
ExecStart=
ExecStart=-/sbin/agetty --autologin root --noclear --keep-baud tty%I 115200,38400,9600 \$TERM
EOF
systemctl daemon-reload
systemctl restart $(basename $(dirname $GETTY_OVERRIDE) | sed 's/\.d//')
2022-04-18 13:33:08 +02:00
msg_ok "Customized Container"
2022-03-08 22:39:37 +01:00
fi
2022-04-18 13:33:08 +02:00
msg_info "Cleaning up"
2022-03-08 22:39:37 +01:00
apt-get autoremove >/dev/null
apt-get autoclean >/dev/null
rm -rf /var/{cache,log}/* /var/lib/apt/lists/*
2022-04-18 13:33:08 +02:00
msg_ok "Cleaned"